# About

✨ TPPT (Typed Python PowerPoint Tool) ✨

A modern Python library for creating beautiful PowerPoint presentations with code! 🚀

## Quick Start

```python
--8<-- "codes/quick_start.py"
```

## Features

- 🛡️ **Type-Safe Development**
    - Full type hints for better IDE support
    - Catch errors before runtime
    - Enhanced code maintainability

- 📝 **Declarative PowerPoint Creation**
    - Write presentations like code
    - Clean and readable syntax
    - Focus on content, not formatting

- 🎨 **Smart Templates**
    - Type-safe template system
    - Reusable slide components
    - Extensible helper functions
    - Build your own presentation tools

- 📊 **Data Integration**
    - Seamless pandas/polars DataFrame support


## Getting Started

To get started with TPPT, check out the [Installation](home/installation.md) guide and [Usage](usage/index.md) documentation.

## License

TPPT is licensed under the MIT License.
